<template>
    <div>
        <div v-if='routeName!="showDashboard" && routeName!="showLogin" && routeName!="showRegister" && routeName!="resetPassword"'>
            <aside class="page-sidebar">
                <div class="page-logo">
                    <router-link to="/index" class="page-logo-link press-scale-down d-flex align-items-center position-relative">
                        <img src="/img/Sapfonte-logo-tran70.png" style="width:150px" alt="Sapfonte" aria-roledescription="logo">
                        <span class="position-absolute text-white opacity-50 small pos-top pos-right mr-2 mt-n2"></span>
                    </router-link>
                </div>
                <!-- BEGIN PRIMARY NAVIGATION -->
                <nav id="js-primary-nav" class="primary-nav" role="navigation">
                    <div class="info-card">
                        <img :src="gravatar" class="profile-image rounded-circle" alt="Dr. Codex Lantern">
                        <div class="info-card-text">
                            <a href="javascript:void(0)" class="d-flex align-items-center text-white">
                                <span class="text-truncate text-truncate-sm d-inline-block">
                                    {{fullName}}
                                </span>
                            </a>
                        </div>
                        <img src="/img/card-backgrounds/cover-2-lg.png" class="cover" alt="cover">
                    </div>
                    <ul id="js-nav-menu" class="nav-menu">
                        <li :class="routeName == 'showIndex' ? 'active' : ''">
                            <router-link to="/index" title="Dashboard">
                                <i class="fal fa-tachometer-alt"></i>
                                <span class="nav-link-text">Dashboard</span>
                            </router-link>
                        </li>
                        <li v-if="findPermission('profile','readOwn') || role=='admin' || role=='user'" :class="routeName == 'showProfile' ? 'active' : ''">
                            <router-link to="/profile" title="Profile">
                                <i class="fal fa-portrait"></i>
                                <span class="nav-link-text">My Profile</span>
                            </router-link>
                        </li >
                        <li v-if="findPermission('profile','readAny') || role=='admin'" :class="routeName == 'showUsers' ||routeName=='showUserDetail' ? 'active' : ''">
                            <router-link to="/users" title="Surveys">
                                <i class="fal fa-users"></i>
                                <span class="nav-link-text">Users</span>
                            </router-link>
                        </li>
                        <li v-if="findPermission('device','readOwn') || role=='user' || role=='admin'" :class="routeName == 'showDevices' ? 'active' : ''">
                            <router-link to="/devices" title="Devices">
                                <i class="fal fa-desktop"></i>
                                <span class="nav-link-text">My Devices</span>
                            </router-link>
                        </li>
                        <li v-if="findPermission('survey','readAny') || findPermission('survey','readOwn') || role=='user' || role=='admin'"  :class="routeName == 'showSurveys' || routeName=='showSurveyDetail' ? 'active' : ''">
                            <router-link to="/surveys" title="Surveys">
                                <i class="fal fa-chart-bar"></i>
                                <span class="nav-link-text">Surveys</span>
                            </router-link>
                        </li>
                        <li v-if="findPermission('role','readAny') || role=='admin'" :class="routeName == 'showRoles' || routeName=='showAddUserToRole' ? 'active' : ''">
                            <router-link to="/roles" title="Roles">
                                <i class="fal fa-tags"></i>
                                <span class="nav-link-text">Roles</span>
                            </router-link>
                        </li>
                    </ul>
                </nav>
                <!-- END PRIMARY NAVIGATION -->
            </aside>
        </div>
    </div>
</template>

<script>
    export default {
        name: 'Sidenav',
        data() {
            return {
                routeName:'',
                username:'',
                role:'',
                gravatar: '',
                fullName:''
            }
        },
        methods:{
            findPermission(resource,action){
                if(this.role!='user' && this.role!='admin'){
                    if(this.role.permissions.find(item => item.resource == resource && item.action == action)){
                        return true
                    }
                    else{
                        return false
                    }
                }
            }
        },
        created(){
            this.$routeName = this.$route.name
            this.routeName = this.$routeName
            this.username = localStorage.getItem("username")
            this.role = JSON.parse(localStorage.getItem("role"))
            this.gravatar = localStorage.getItem("gravatar")
            this.fullName = localStorage.getItem("fullName")
        },
        watch:{
            $route()
            {
                this.$routeName = this.$route.name
                this.routeName = this.$routeName
            }
        }
    }
</script>

<style scoped>

</style>